class CharStatStore {
    public char character;
    private int character_value;
    private int occurances;
    private double frequency;
    private PrecederStatistic[] prestat;

    CharStatStore(char ch, int chval) {
	character = ch;
	character_value = chval;
	prestat = new PrecederStatistic[256];
    }
    
    /* This means that the char represented by this
     * object occurred after the character "after" in
     * the argument to this function.
     */
    public void addOccurance(char follower) {
	occurances ++;
	int cval = (int) follower; // Character.getNumericValue(follower);
	if (cval < 0 || cval > 255)
	    return;
	// Locate the follower in the stats store
	if (prestat[cval] == null) {
	    prestat[cval] = new PrecederStatistic();
	    prestat[cval].character = follower;
	}
	prestat[cval].occurances++;
    }

    public void calcStats(int totalchars) {
	int ack_occ = 0;

	frequency = (double) occurances / (double) totalchars;
	for (int i=0; i < 256; i++) {
	    if (prestat[i] != null) {		
		prestat[i].frequency = (double) prestat[i].occurances / (double) occurances;
		prestat[i].interval_lo = (double) ack_occ / (double) occurances;
		ack_occ += prestat[i].occurances;
		prestat[i].interval_hi = (double) ack_occ / (double) occurances;
	    }
	}
    }

    /* Prints out the statistics */
    public void dumpStats() {
	System.out.print(character + " : " + frequency);
	for (int i=0; i < 256; i++) {
	    if (prestat[i] != null) {
		int ackumulated_occ;
		System.out.print("," + prestat[i].character + "*" + prestat[i].occurances);
		System.out.print(" lo=" + prestat[i].interval_lo + " hi=" + prestat[i].interval_hi);
	    }
	}
	System.out.println();
    }

    /* Selects the succeeding character based on a random integer
     * in the interval 0..1 */
    public char getFollower(double rand) {
	for (int i=0; i < 256; i++) {
	    if (prestat[i] != null &&
		rand >= prestat[i].interval_lo &&
		rand <= prestat[i].interval_hi) {
		return prestat[i].character;
	    }
	}
	return ' '; // Beep
    }

    /* An inner class to represent the statistics for each
     * character that has ever followed this character */
    class PrecederStatistic {
	public char character;
	public int occurances;
	/* Statistical probability frequency, the probability
	 * that this precedes that char
	 */
	public double frequency;
	/* The interval for each character in the range 0..1
	 * that it will be responding to on a randon integer
	 * in that interval
	 */
	public double interval_lo;
	public double interval_hi;
    }
}
