import java.io.*;

class Lexer {
    private int linecount = 0;
    private String line = null;
    private int lineIndex = 0;
    private BufferedReader inStream = null;
    private boolean returnedwhitespace = true;

    Lexer(String filename) {
	try {
	    inStream = new BufferedReader(new FileReader(filename));
	}
	catch (FileNotFoundException e) {
	    System.out.println("Could not open file: " + filename);
	    System.exit(1);
	}
    }

    public char get() {
	String whiteSpace = " \t\n\r=^*/+-()\\{};.0123456789";
	
	for (;;) {
	    if (line == null) {
		try {
		    line = inStream.readLine();
		} catch (IOException e) {
		    /* Handle this exception or throw further? */
		    System.out.println("Error on reading source file. Execution terminated.");
		    System.exit(1);
		}
		if (line == null)
		    return '\0';
		else {
		    linecount ++;
		    lineIndex = 0;
		}
	    }
	    if (lineIndex < line.length()) {
		char current = Character.toLowerCase(line.charAt(lineIndex));

		if (!Character.isLetter(current)) {
		    lineIndex++;
		    if (!returnedwhitespace) {
			returnedwhitespace = true;
			return ' ';
		    }
		} else {
		    lineIndex++;
		    returnedwhitespace = false;
		    return current;
		}
	    } else {
		line = null;
	    }
	}
    }

}
