import java.util.Random;

class Wordgenerator {
    private CharStatStore[] charstatstores;
    Random mrRandom;
    Syntax mrSyntax;

    Wordgenerator(CharStatStore[] stst, Syntax syntax) {
	charstatstores = stst;
	mrSyntax = syntax;
	mrRandom = new Random();
    }

    /* Generate a single word */
    private String generateWord() {
	String word = "";
	char lastchar = ' '; // Begin with space = new word. 
	boolean generated = false;

	while (!generated) {
	    for (int i = 0; i < 256; i++) {
		if (charstatstores[i] != null &&
		    charstatstores[i].character == lastchar) {
		    lastchar = charstatstores[i].getFollower(mrRandom.nextDouble());
		    if (lastchar == ' ')
			generated = true;
		    else
			word += lastchar;
		}
	    }
	    // Discriminate invalid words
	    if (generated) {
		if (!mrSyntax.testWord(word)) {
		    generated = false;
		    if (word.length() > 3) {
			word = "";
			lastchar = ' ';
		    }
		}
	    }
	}
	return word;
    }

    /* generates words number of random words */
    public void generateWords(int words) {
	int generated = 0;
	
	while(generated < words) {
	    System.out.print(generateWord() + " ");
	    generated ++;
	}
	System.out.println();
    }

}
